import { isPipeline } from './util.js';
function createRoute(name, path, action, meta) {
    if (isPipeline(action)) {
        const h = action.pop();
        return [
            path,
            {
                [name]: h,
                middleware: [...action],
                meta,
            },
        ];
    }
    else {
        return [path, { [name]: action, middleware: [], meta }];
    }
}
// use partial func application below
export function GET(path, action, meta = {}) {
    return createRoute('GET', path, action, meta);
}
export function POST(path, action, meta = {}) {
    return createRoute('POST', path, action, meta);
}
export function PATCH(path, action, meta = {}) {
    return createRoute('PATCH', path, action, meta);
}
export function PUT(path, action, meta = {}) {
    return createRoute('PUT', path, action, meta);
}
export function DELETE(path, action, meta = {}) {
    return createRoute('DELETE', path, action, meta);
}
export function OPTIONS(path, action, meta = {}) {
    return createRoute('OPTIONS', path, action, meta);
}
export function ANY(path, action, meta = {}) {
    return createRoute('ANY', path, action, meta);
}
